#ifndef SUITE2_HPP
#define SUITE2_HPP
#include <cmath>
#include <iostream>

using namespace std;

template< class T, int n> class suite2 {
  T A[n*n];
  T b[n];
  T u0[n];
  T un[n];
  int indice_k(int i,int j){
    return i+j*n;
  }
  
public: 
  suite2 (){
    int k =0;
    for(int i =0; i<n;i++){
      b[i] = T();
      un[i] = T();
      u0[i] = T();
      for(int j =0; j<n;j++){
	A[indice_k(i,j)] = T();
      }
    }
  }
  suite2 (const suite2 & x){
    int k=0;
    for(int i =0; i<n;i++){
      b[i] = x.b[i];
      un[i] = x.un[i];
      u0[i] = x.u0[i];
      for(int j =0; j<n;j++){
	A[indice_k(i,j)] = T();
      }
    }
  }
  ~suite2 (){
  }
  suite2 & operator = (const suite2 &);
  suite2 operator + (const suite2 &);
  void set_bi(int, double);
  void set_Aij(int,int, double);
  void set_u0i(int, double);
  void plot_un();
  void term_n(int);
};

template<class T, int n> suite2<T,n> & suite2<T,n>::operator = (const suite2<T,n> & x){
  int k=0;
  if(this != & x){ // autoaffectation
    for(int i =0; i<n;i++){
      b[i] = x.b[i];
      un[i] = x.un[i];
      for(int j =0; j<n;j++){
	A[indice_k(i,j)] = x.A[indice_k(i,j)];
      }
    }
  }
  return *this;
}

template<class T, int n> suite2<T,n> suite2<T,n>::operator + (const suite2<T,n> & x){
  suite2<T,n> res;
  int k =0;
  for(int i =0; i<n;i++){
    res.b[i] = b[i] + x.b[i];
    res.un[i] = un[i] + x.un[i];
    for(int j =0; j<n;j++){
      res.A[indice_k(i,j)] = A[indice_k(i,j)] + x.A[indice_k(i,j)];
      cout<<"i >> "<<i<<"j >>"<<j<<" A "<<res.A[indice_k(i,j)]<<endl;
    }
  }
  return res;
}

template<class T, int n> void suite2<T,n>::set_bi(int i , double x){
  b[i] = x;
}

template<class T, int n> void suite2<T,n>::set_u0i(int i , double x){
  un[i] = x;
}

template<class T, int n> void suite2<T,n>::set_Aij(int i, int j , double x){
  A[indice_k(i,j)] = x;
}


template<class T, int n> void suite2<T,n>::term_n(int niter){
  double * u = new double[n];
  double sum;

  for(int i =0; i<n;i++){
    un[i] = u0[i];
  }

  for(int ni =0; ni<niter;ni++){
    for(int i =0; i<n;i++){
      u[i] = un[i];
    }
    for(int i =0; i<n;i++){
      sum=0;
      for(int j =0; j<n;j++){
	sum = sum + A[indice_k(i,j)]*u[j];
      }
      u[i] = sum + b[i];
    }
    for(int i =0; i<n;i++){
  	un[i] = u[i];
    }
  }
}

template<class T, int n> void suite2<T,n>::plot_un(){
    for(int i =0; i<n;i++){
      cout<<"ieme terme de un :"<<un[i]<<endl;;
    }
}

#endif
